//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "PointerUnit.h"
//----------------------------------------------------------------------------//
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//----------------------------------------------------------------------------//
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//----------------------------------------------------------------------------//
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
  switch(ComboBox1->ItemIndex)
  {
    case 0: demoShowPointerAndRangeCheck(Sender); break;
    case 1: demoStaticArraysAreOnlyOneDimension(Sender); break;
    case 2: demoSizeOf(Sender); break;
    case 3: demoSizeOfDataStructure(Sender); break;
    case 4: demoPointerOperation(Sender); break;
    case 5: demoArray2isOneDimension(Sender); break;
    case 6: demoArray3isOneDimension(Sender); break;
    case 7: demoStaticArrayPointerOperation(Sender); break;
    case 8:
    case 9:
    case 10:
    case 11:
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
    default: break;
  }
}
//----------------------------------------------------------------------------//
// Q printf() qXСAPɮi C/C++ |zˬd}Cd
void __fastcall TForm1::demoShowPointerAndRangeCheck(TObject *Sender)
{
  AnsiString asBuf=EmptyStr;

  int Array[100];             // ŧi 100 Ӿ

  for(int i=0;i<200;i++)      // GNϥ 200 ӡII
    asBuf.cat_printf("&Array[%3d]=%p  Array[%3d]=%d\n",i,&Array[i],i,Array[i]);

  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//
// RAh}CiH@}C
// iѵGݨARAh}CЬOs򪺡AҥHiH@}CC
void __fastcall TForm1::demoStaticArraysAreOnlyOneDimension(TObject *Sender)
{
  AnsiString asBuf=EmptyStr;
  // asBuf.cat_printf("Button2Click=%p",&TForm1::Button2Click);
  byte *Array1;                // Array1 @ӫܼ
  byte Array2[2][3];           // Array2 @ӤG}C
  byte Array3[2][3][2];        // Array3 @ӤT}C
  int i,j,k;

  Array1=&Array2[0][0];       // N Array1 V Array2 Ĥ@Ӥ}

  for(i=0;i<2*3;i++)          // N Array1  Array1[2*3] @}C
    Array1[i]=i;

  for(i=0;i<2;i++)            //  Array2 LXӬݬ
    for(j=0;j<3;j++)
      asBuf.cat_printf("&Array2[%d][%d]=%p  Array2[%d][%d]=%d\n",
        i,j,&Array2[i][j],i,j,Array2[i][j]);

                              // ѩѨS@ˬdAҥH]iHNG}C
  i=0;                        // Ĥ@ӯޭȳ] 0  AuβĤGӯޭȨӦs
  for(j=0;j<2*3;j++)          // ơANO@Ӥ@}C@ˡC
    asBuf.cat_printf("&Array2[%d][%d]=%p  Array2[%d][%d]=%d\n",
      i,j,&Array2[i][j],i,j,Array2[i][j]);

  Array1=&Array3[0][0][0];    // N Array1 V Array3 Ĥ@Ӥ}C

  for(i=0;i<2*3*2;i++)        // N Array1  Array1[2*3*2] @}C
    Array1[i]=i;

  for(i=0;i<2;i++)            //  Array3 LXӬݬ
    for(j=0;j<3;j++)
      for(k=0;k<2;k++)
        asBuf.cat_printf("&Array3[%d][%d][%d]=%p  Array3[%d][%d][%d]=%d\n",
          i,j,k,&Array3[i][j][k],i,j,k,Array3[i][j][k]);
                              // ѩѨS@ˬdAҥH]iHNT}C
  i=0; j=0;                   // Ĥ@BGӯޭȳ] 0 AuβĤTӯޭȨ
  for(k=0;k<2*3*2;k++)        // sơANO@Ӥ@}C@ˡC
    asBuf.cat_printf("&Array3[%d][%d][%d]=%p  Array3[%d][%d][%d]=%d\n",
      i,j,k,&Array3[i][j][k],i,j,k,Array3[i][j][k]);

  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//
//  sizeof dܼƥeΰO骺jp
void __fastcall TForm1::demoSizeOf(TObject *Sender)
{
  AnsiString asBuf=EmptyStr;
  asBuf.cat_printf("size of (char)        = %d\n",sizeof(char)    );
  asBuf.cat_printf("size of (short)       = %d\n",sizeof(short)   );
  asBuf.cat_printf("size of (int)         = %d\n",sizeof(int)     );
  asBuf.cat_printf("size of (long)        = %d\n",sizeof(long)    );
  asBuf.cat_printf("size of (float)       = %d\n",sizeof(float)   );
  asBuf.cat_printf("size of (double)      = %d\n",sizeof(double)  );
  asBuf.cat_printf("size of (char *)      = %d\n",sizeof(char *)  );
  asBuf.cat_printf("size of (short *)     = %d\n",sizeof(short *) );
  asBuf.cat_printf("size of (int *)       = %d\n",sizeof(int *)   );
  asBuf.cat_printf("size of (long *)      = %d\n",sizeof(long *)  );
  asBuf.cat_printf("size of (float *)     = %d\n",sizeof(float *) );
  asBuf.cat_printf("size of (double *)    = %d\n",sizeof(double *));
  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//
// Ӭݦ@˪cA|] Data Alignment ]wPAjp]|PI
void __fastcall TForm1::demoSizeOfDataStructure(TObject *Sender)
{
  typedef struct {            // H`ѦATestSize1 P TestSize2 jpۦP
    char  c;                  // B char (1) + short (2) + int (4) = 7 bytes
    short s;                  // ƹW|] Compile  Data Alignment ]wӲI
    int   i;                  // Alignment
  } TestSize1;                // Byte         TestSize1=7 , TestSize2=7
  typedef struct {            // Word         TestSize1=8 , TestSize2=8
    char  c;                  // Double Word  TestSize1=8 , TestSize2=12
    int   i;                  // Quad Word    TestSize1=8 , TestSize2=12
    short s;                  //  ̦nϥ sizeof() ӭp struct jpA
  } TestSize2;                //    ӤnۤvpC

  TestSize1 a;
  TestSize2 b;

  AnsiString asBuf=EmptyStr;
  asBuf.cat_printf("size of (TestSize1)   = %d\n",sizeof(TestSize1));
  asBuf.cat_printf("size of (TestSize2)   = %d\n",sizeof(TestSize2));
  asBuf.cat_printf("size of (TestSize1 *) = %d\n",sizeof(TestSize1 *));
  asBuf.cat_printf("size of (TestSize2 *) = %d\n",sizeof(TestSize2 *));
  asBuf.cat_printf("pointer of a.c =%p\n",&a.c);
  asBuf.cat_printf("pointer of a.s =%p\n",&a.s);
  asBuf.cat_printf("pointer of a.i =%p\n",&a.i);
  asBuf.cat_printf("pointer of b.c =%p\n",&b.c);
  asBuf.cat_printf("pointer of b.i =%p\n",&b.i);
  asBuf.cat_printf("pointer of b.s =%p\n",&b.s);
  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//
// ܼƨC +  - OHƫAjpb
void __fastcall TForm1::demoPointerOperation(TObject *Sender)
{
  char  *cPointer=NULL;
  short *sPointer=NULL;
  int   *iPointer=NULL;

  AnsiString asBuf=EmptyStr;
  for(int i=0;i<5;i++)
    asBuf.cat_printf("cPointer%+d=%p\n",i,cPointer++);
  for(int i=0;i<5;i++)
    asBuf.cat_printf("sPointer%+d=%p\n",i,sPointer++);
  for(int i=0;i<5;i++)
    asBuf.cat_printf("iPointer%+d=%p\n",i,iPointer++);
  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//
// QGRAGܼƭnpŧiƨ禡JOH
//  int **Array=Array2; O compile LFI
// bvBz``Ψ 3x3 x}BAӯx}B⦡OTwA
// gFƨ禡pGLkHGܼƨӶǡAnpǩOH
void __fastcall ProcessArray2x3(int Array[][3])
{
  for(int i=0;i<2;i++)            // Bz Array[2][3]
    for(int j=0;j<3;j++)
      Array[i][j]=(i+1)*10+(j+1);
}
void __fastcall TForm1::demoArray2isOneDimension(TObject *Sender)
{
  int Array2[2][3];

  ProcessArray2x3(Array2);

  AnsiString asBuf=EmptyStr;
  for(int i=0;i<2;i++)            //  Array2 LXӬݬ
    for(int j=0;j<3;j++)
      asBuf.cat_printf("&Array2[%d][%d]=%p  Array2[%d][%d]=%u\n",
        i,j,&Array2[i][j],i,j,Array2[i][j]);
  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//
// QGRATܼƭnpŧiƨ禡JOH
void __fastcall ProcessArray2x3x2(byte Array[][3][2])
{
  for(int i=0;i<2;i++)            // Bz Array[2][3][2]
    for(int j=0;j<3;j++)
      for(int k=0;k<2;k++)
        Array[i][j][k]=(i+1)*100+(j+1)*10+k+1;
}
void __fastcall TForm1::demoArray3isOneDimension(TObject *Sender)
{
  byte Array3[2][3][2];

  ProcessArray2x3x2(Array3);

  AnsiString asBuf=EmptyStr;
  for(int i=0;i<2;i++)            //  Array2 LXӬݬ
    for(int j=0;j<3;j++)
      for(int k=0;k<2;k++)
        asBuf.cat_printf("&Array3[%d][%d][%d]=%p  Array3[%d][%d][%d]=%u\n",
          i,j,k,&Array3[i][j][k],i,j,k,Array3[i][j][k]);
  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//
// ϥΫЪܪks}C
void __fastcall TForm1::demoStaticArrayPointerOperation(TObject *Sender)
{
  byte Array1[5];
  byte Array2[2][3];

  for(int i=0;i<5;i++)   *(Array1+i)=i;
  for(int i=0;i<2*3;i++) *(*Array2+i)=i;

  AnsiString asBuf=EmptyStr;
  for(int i=0;i<5;i++)
      asBuf.cat_printf("&Array1[%d]=%p  Array1[%d]=%d\n",
                        i,Array1+i,i,*(Array1+i));
  for(int i=0;i<2;i++)
    for(int j=0;j<3;j++)
      asBuf.cat_printf("&Array2[%d][%d]=%p  Array2[%d][%d]=%d\n",
                        i,j,*(Array2+i)+j,i,j,*(*(Array2+i)+j));
  ListBox1->Items->Text=asBuf;
}
//----------------------------------------------------------------------------//

